<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfMotivosIsencaoIvaERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfMotivosIsencaoIvaERP
 * @subpackage Arrays
 */
class ArrayOfMotivosIsencaoIvaERP extends AbstractStructArrayBase
{
    /**
     * The MotivosIsencaoIvaERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\MotivosIsencaoIvaERP[]
     */
    public $MotivosIsencaoIvaERP;
    /**
     * Constructor method for ArrayOfMotivosIsencaoIvaERP
     * @uses ArrayOfMotivosIsencaoIvaERP::setMotivosIsencaoIvaERP()
     * @param \StructType\MotivosIsencaoIvaERP[] $motivosIsencaoIvaERP
     */
    public function __construct(array $motivosIsencaoIvaERP = array())
    {
        $this
            ->setMotivosIsencaoIvaERP($motivosIsencaoIvaERP);
    }
    /**
     * Get MotivosIsencaoIvaERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\MotivosIsencaoIvaERP[]|null
     */
    public function getMotivosIsencaoIvaERP()
    {
        return isset($this->MotivosIsencaoIvaERP) ? $this->MotivosIsencaoIvaERP : null;
    }
    /**
     * Set MotivosIsencaoIvaERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\MotivosIsencaoIvaERP[] $motivosIsencaoIvaERP
     * @return \ArrayType\ArrayOfMotivosIsencaoIvaERP
     */
    public function setMotivosIsencaoIvaERP(array $motivosIsencaoIvaERP = array())
    {
        foreach ($motivosIsencaoIvaERP as $arrayOfMotivosIsencaoIvaERPMotivosIsencaoIvaERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfMotivosIsencaoIvaERPMotivosIsencaoIvaERPItem instanceof \StructType\MotivosIsencaoIvaERP) {
                throw new \InvalidArgumentException(sprintf('The MotivosIsencaoIvaERP property can only contain items of \StructType\MotivosIsencaoIvaERP, "%s" given', is_object($arrayOfMotivosIsencaoIvaERPMotivosIsencaoIvaERPItem) ? get_class($arrayOfMotivosIsencaoIvaERPMotivosIsencaoIvaERPItem) : gettype($arrayOfMotivosIsencaoIvaERPMotivosIsencaoIvaERPItem)), __LINE__);
            }
        }
        if (is_null($motivosIsencaoIvaERP) || (is_array($motivosIsencaoIvaERP) && empty($motivosIsencaoIvaERP))) {
            unset($this->MotivosIsencaoIvaERP);
        } else {
            $this->MotivosIsencaoIvaERP = $motivosIsencaoIvaERP;
        }
        return $this;
    }
    /**
     * Add item to MotivosIsencaoIvaERP value
     * @throws \InvalidArgumentException
     * @param \StructType\MotivosIsencaoIvaERP $item
     * @return \ArrayType\ArrayOfMotivosIsencaoIvaERP
     */
    public function addToMotivosIsencaoIvaERP(\StructType\MotivosIsencaoIvaERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\MotivosIsencaoIvaERP) {
            throw new \InvalidArgumentException(sprintf('The MotivosIsencaoIvaERP property can only contain items of \StructType\MotivosIsencaoIvaERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->MotivosIsencaoIvaERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\MotivosIsencaoIvaERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\MotivosIsencaoIvaERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\MotivosIsencaoIvaERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\MotivosIsencaoIvaERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\MotivosIsencaoIvaERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string MotivosIsencaoIvaERP
     */
    public function getAttributeName()
    {
        return 'MotivosIsencaoIvaERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfMotivosIsencaoIvaERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
